﻿
namespace Physics
{
    namespace PhysicalQuantities
    {
        public partial class Energy : IPhysical
        {   


            public double ValueToUnit(string unitSimbol)
            {
                
                switch (unitSimbol)
                {
                    //TODO: Verificare che l'oggetto sia kelvin e no altro
                    case "J":
                        return  (_value);

                    case "Kcal":
                        return  (_value * 0.000239006);

                    case "Wh":
                        return  (_value * 0.000277778);

                    case "KWh":
                       return  (_value * 0.000000277778);

                    case "eV":
                        return  (_value * 6.242E+18);
            
                    case "Btu":
                        return  (_value * 0.000947817);
                
                    case "Atu":
                        return  (_value * 0.0000000094804);
              
                    case "ft lbs":
                        return  (_value * 0.737562);
           
                    default:
                        return  (_value);
                }
            }

            /// <summary>
            /// Converts the value of \"unitSimbol\" to Joule
            /// </summary>
            /// <returns>value of Joule</returns>
            public double ValueFromUnit()
            {
                switch (_unitSymbol)
                {
                    case "J":
                        return (_value);

                    case "Kcal":
                        return (_value / 0.000239006);

                    case "Wh":
                        return (_value / 0.000277778);

                    case "KWh":
                        return (_value / 0.000000277778);

                    case "eV":
                        return (_value / 6.242E+18);

                    case "Btu":
                        return (_value / 0.000947817);

                    case "Atu":
                        return (_value / 0.0000000094804);

                    case "ft lbs":
                        return (_value / 0.737562);

                    default:
                        return UnitAbsValue[0];
                }
            }



            /// <summary>
            /// Converts the value of kelvin to \"unitSimbol\"
            /// </summary>
            /// <returns>New Instance in \"UnitSimbol\" degrees</returns>
            public object ObjectToUnit(string UnitSimbol)
            {
                return new Energy(UnitSimbol, ValueToUnit(UnitSimbol));
            }

            /// <summary>
            /// Converts the value of \"unitSimbol\" to Kelvin
            /// </summary>
            /// <returns>New Instance in kelvin degrees</returns>
            public object ObjectFromUnit()
            {
                return new Energy(ValueFromUnit());
            }




            /// <summary>
            /// Converts a Energy object to the chosen thermometric scale
            /// </summary>
            /// <param name="UnitSimbOut">Output thermometer scale symbol</param>
            /// <returns>New instance of Energy</returns>
            public object ObjectUnitToUnit(string UnitSimbOut)
            {
                // Prima Conversione
                // Converte il valore dell'oggetto in gradi Kelvin
                IPhysical Temporaneo = (IPhysical)ObjectFromUnit();

                return Temporaneo.ObjectToUnit(UnitSimbOut);
            }
            /// <summary>
            /// Values the unit to unit.
            /// </summary>
            /// <param name="UnitSimbOut">The unit simb out.</param>
            /// <returns></returns>
            public double ValueUnitToUnit(string UnitSimbOut)
            {
                // Creo una 2° instanza per evitare modicfiche alla 1°
                Energy temp = new Energy(ValueFromUnit());
                temp.Unit_Value  = temp.ValueToUnit(UnitSimbOut) ;
                temp.Unit_Symbol = UnitSimbOut;
              
                return temp.Unit_Value;
            }




            /// <summary>
            /// Redefines the object.
            /// </summary>
            /// <param name="symbol">Symbol of the new unit</param>
            /// <param name="value">value of the new unit</param>
            public void RedefineObject(string symbol, double value)
            {
              //  if (CheckUnitName(symbol) && ValidateValue(symbol, value))
              //  {
                    _value = value;
                    _unitSymbol = symbol;
              //  }
            }
        }
    }
}