﻿namespace Physics
{
    namespace PhysicalQuantities
    {
        /// Generic class on the Elements of Physical Quanties
        public class ItemsPQ
        {
            /// <summary>Array containing the names of the Physical Quanties</summary> 
            public static string[] NameOfPQ = 
                { "Temperatura", "Pressione","Distanza","Energia" };

            /// <summary>
            /// Number of quantities present in the dll
            /// </summary>
            public static int count = NameOfPQ.Length;

            /// <summary>
            ///Method for choosing the correct class 
            /// </summary>
            /// <param name="index">Index relative to the class 
            /// from which to instantiate the object</param>
            /// <returns>Generic constructor for the class</returns>
            public static IPhysical ChoosePQ(int index)
            {
                switch (index)
                {
                    case 0:
                        return new Temperature();
                    case 1:
                        return new Pressure();
                    case 2:
                        return new Distance();
                    case 3:
                        return new Energy();
                    default:
                        return null;
                }
            }

        }
    }
}
