﻿namespace Physics
{
    namespace PhysicalQuantities
    {
        public partial class Pressure : IPhysical
        {
            public double ValueToUnit(string unitSimbol)
            {

                switch (unitSimbol)
                {

                    case "Pa":
                        return _value;

                    case "bar":
                        return _value * 0.00001;

                    case "torr":
                        return _value * 0.0075006;

                    case "mmH2O":
                        return _value * 0.1019744;

                    case "atm":
                        return _value * 0.0000098;

                    case "kgt":
                        return _value * 0.101972;

                    case "ata":
                        return _value * 0.0000102;

                    case "Ba":
                        return _value * 10.0;

                    default:
                        return _value;
                }
            }

            public double ValueFromUnit()
            {
                switch (_unitSymbol)
                {
                    case "ata":
                        return _value / 0.0000102;
                    case "Ba":
                        return _value / 10.0;
                    case "Pa":
                        return _value;
                    case "bar":
                        return _value / 0.00001;
                    case "torr":
                        return _value / 0.0075006;
                    case "mmH2O":
                        return _value / 0.1019744;
                    case "atm":
                        return _value / 0.0000098;
                    case "kgt":
                        return _value / 0.101972;

                    default:
                        return UnitAbsValue[0];
                }
            }
        }
    }
}