﻿
namespace Physics
{
    namespace PhysicalQuantities
    {
        /// <summary>
        /// Class that manages the temperature
        /// </summary>
        /// <seealso cref="Physics.PhysicalQuantities.IPhysical" />
        public partial class Temperature : IPhysical
        {   

            /// <summary>
            /// Converts the value of kelvin to \"unitSimbol\"
            /// </summary>
            /// <returns>New Instance in \"UnitSimbol\" degrees</returns>
            public object ObjectToUnit(string UnitSimbol)
            {
                return new Temperature(UnitSimbol, ValueToUnit(UnitSimbol));
            }

            /// <summary>
            /// Converts the value of \"unitSimbol\" to Kelvin
            /// </summary>
            /// <returns>New Instance in kelvin degrees</returns>
            public object ObjectFromUnit()
            {
                return new Temperature(ValueFromUnit());
            }

            /// <summary>
            /// Converts a Temperature object to the chosen thermometric scale
            /// </summary>
            /// <param name="UnitSimbOut">Output thermometer scale symbol</param>
            /// <returns>New instance of Temperature</returns>
            public object ObjectUnitToUnit(string UnitSimbOut)
            {
                // Prima Conversione
                // Converte il valore dell'oggetto in gradi Kelvin
                IPhysical Temporaneo = (IPhysical)ObjectFromUnit();

                return Temporaneo.ObjectToUnit(UnitSimbOut);
            }
            
            /// <summary>
            /// Values the unit to unit.
            /// </summary>
            /// <param name="UnitSimbOut">The unit simb out.</param>
            /// <returns></returns>
            public double ValueUnitToUnit(string UnitSimbOut)
            {
                // Creo una 2° instanza per evitare modicfiche alla 1°
                Temperature temp = new Temperature(ValueFromUnit());
                this.Unit_Value  = temp.ValueToUnit(UnitSimbOut) ;
                this.Unit_Symbol = UnitSimbOut;
              
                return Unit_Value;
            }
           
            /// <summary>
            /// Redefines the object.
            /// </summary>
            /// <param name="symbol">Symbol of the new unit</param>
            /// <param name="value">value of the new unit</param>
            public void RedefineObject(string symbol,double value)
            {
                if (CheckUnitName(symbol) && ValidateValue(symbol, value))
                {
                    _value = value;
                    _unitSymbol = symbol;
                }
            }
        }
    }
}