﻿namespace Physics
{
    namespace PhysicalQuantities
    {
        public partial class Temperature : IPhysical
        {
            public double ValueToUnit(string unitSimbol)
            {
                switch (unitSimbol)
                {
                    //TODO: Verificare che l'oggetto sia kelvin e no altro
                    case "k":
                        return _value;

                    case "°C":
                        return _value - 273.15;

                    case "°F":
                        return _value * (9.0 / 5.0) - 459.67;

                    case "°R":
                        return _value * (9.0 / 5.0);

                    case "°De":
                        return (373.15 - _value) * (3.0 / 2.0);

                    case "°N":
                        return (_value - 273.15) * (33.0 / 100.0);

                    case "°r":
                        return (_value - 273.15) * (4.0 / 5.0);

                    case "°Rø":
                        return (_value - 273.15) / (40.0 / 21.0) + 7.5;

                    default:
                        return _value;
                }
            }

            public double ValueFromUnit()
            {
                switch (_unitSymbol)
                {
                    case "k":
                        return _value;

                    case "°C":
                        return _value + 273.15;

                    case "°F":

                        return (_value + 459.67) * (5.0 / 9.0);

                    case "°R":
                        return _value * (5.0 / 9.0);

                    case "°De":
                        return 373.15 - (_value * (2.0 / 3.0));

                    case "°N":
                        return _value * (100.0 / 33.0) + 273.15;

                    case "°r":
                        return (_value * (5.0 / 4.0)) + 273.15;

                    case "°Rø":
                        return ((_value - 7.5) * (40.0 / 21.0)) + 273.15;

                    default:
                        return UnitAbsValue[0];
                }
            }
        }
    }
}